/* CORBA_Object_help.java */
/* Chris Jacobi, March 13, 1997 12:15 pm PST */

/*
 * Copyright (c) 1997 Xerox Corporation.  All Rights Reserved.  
 * Unlimited use, reproduction, and distribution of this software is
 * permitted.  Any copy of this software must include both the above
 * copyright notice of Xerox Corporation and this paragraph.  Any
 * distribution of this software must comply with all applicable United
 * States export control laws.  This software is made available AS IS,
 * and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
 * INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
 * PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
 * THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
 * CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
 * XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 */
 
/* $Id: CORBA_Object_help.java,v 1.1 1997/03/13 20:34:15 jacobi Exp $ */

package xerox.ilu;

public class CORBA_Object_help implements xerox.ilu.IluIOFunctions  {
    private final static java.lang.String _id = 
        "IDL:omg.com/CORBA/Object:1.0";
    
    private static xerox.ilu.TypeCode _tc =
        xerox.ilu.TypeCode.corba_objref();

    public final static java.lang.String id() {
        return _id;
    } //id 

    public final static xerox.ilu.TypeCode type() {
        return _tc;
    } //type 

    public static CORBA_Object narrow(xerox.ilu.IluObject _x) {
        return (CORBA_Object) _x;
    } //narrow 

    public static xerox.ilu.Any insert(CORBA_Object _x) 
            throws xerox.ilu.IluSystemException {
        xerox.ilu.Any _any = new xerox.ilu.Any();
        xerox.ilu.Pickle _pickle = to_pickle(_x);
        _any.setPickle(_pickle);
        return _any;
    } //insert 

    public static CORBA_Object extract(xerox.ilu.Any _any) 
            throws xerox.ilu.IluSystemException {
        xerox.ilu.Pickle _pickle = _any.getPickle();
        return from_pickle(_pickle);
    } //extract 

    public static xerox.ilu.Pickle to_pickle(CORBA_Object _x) 
            throws xerox.ilu.IluSystemException {
        int _sz = 0;
        xerox.ilu.IluCall _call = null;
        xerox.ilu.Pickle _pickle = new xerox.ilu.Pickle();
        try {
            _call = _pickle.startToPickle();
            _sz = _call.szObject(_x, false, CORBA_Object_stub.iluClass());
            _pickle.midToPickle(_call, _sz, id());
            _call.outObject(_x, false, CORBA_Object_stub.iluClass());
        } finally {
            _pickle.endToPickle(_call);
        }
        return _pickle;
    } //to_pickle 

    public static CORBA_Object from_pickle(xerox.ilu.Pickle _pickle) 
            throws xerox.ilu.IluSystemException {
        CORBA_Object _x = null;
        xerox.ilu.IluCall _call = null;
        try {
            _call = _pickle.startFromPickle(id());
            _x = (CORBA_Object) _call.inObject(
                false, CORBA_Object_stub.iluClass());
        } finally {
            _pickle.endFromPickle(_call);
        }
        return _x;
    } //from_pickle 

    /** Not public; implements xerox.ilu.IluIOFunctions */
    public int szFunc(
            xerox.ilu.IluCall _call, 
            java.lang.Object _x, 
            xerox.ilu.TypeCode _tc) 
            throws xerox.ilu.IluSystemException {
        CORBA_Object _xx = (CORBA_Object)_x;
        return _call.szObject(_xx, false, CORBA_Object_stub.iluClass());
    } //szFunc 

    /** Not public; implements xerox.ilu.IluIOFunctions */
    public void outFunc(
            xerox.ilu.IluCall _call, 
            java.lang.Object _x, 
            xerox.ilu.TypeCode _tc) 
            throws xerox.ilu.IluSystemException {
        CORBA_Object _xx = (CORBA_Object)_x;
        _call.outObject(_xx, false, CORBA_Object_stub.iluClass());
    } //outFunc 

    /** Not public; implements xerox.ilu.IluIOFunctions */
    public java.lang.Object inFunc(
            xerox.ilu.IluCall _call, 
            xerox.ilu.TypeCode _tc) 
            throws xerox.ilu.IluSystemException {
        return (CORBA_Object) _call.inObject(
            false, CORBA_Object_stub.iluClass());
    } //inFunc 

    public boolean isAFunc(Object _x, xerox.ilu.TypeCode _tc) {
        if (_x == null) return false;
        return (_x instanceof CORBA_Object);
    } //isAFunc 

}//CORBA_Object_help

