/* IluJava_GCClient.c */
/* Chris Jacobi, April 7, 1997 11:52 am PDT */

/*
 * Copyright (c) 1996, 1997 Xerox Corporation.  All Rights Reserved.  
 * Unlimited use, reproduction, and distribution of this software is
 * permitted.  Any copy of this software must include both the above
 * copyright notice of Xerox Corporation and this paragraph.  Any
 * distribution of this software must comply with all applicable United
 * States export control laws.  This software is made available AS IS,
 * and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
 * INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
 * PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
 * THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
 * CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
 * XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 */
 
/* $Id: IluJava_GCClient.c,v 1.7 1997/04/08 20:24:28 jacobi Exp $ */
 
/*
 * C side for GCClient.java
 */
 
#include <iluxport.h>
#include <iluerror.h>

#include "IluJava_JStubs.h"
#include "IluJava.h"
#include "xerox_ilu_IluGCClient.h"


EXPORTJAVA long
xerox_ilu_IluGCClient_nativeIsGcClientSet(
	struct Hxerox_ilu_IluGCClient * unused) 
{
    long isSet = 0;
    if (ilu_IsGcClientSet()) isSet = 1; 
    return isSet;
}


EXPORTJAVA void
xerox_ilu_IluGCClient_finishSpecialGCClass(
	struct Hxerox_ilu_IluGCClient * unused,
	struct Hxerox_ilu_IluClassRep * jjClass) 
{
    ilu_Class cClass = ilu_GetGcCallbackClass();
    Access(jjClass, yIluClass, ilu_Class) = cClass;
    if (_ilujava_definitionsFlag>0) {
        ilu_DebugPrintf("$ GCClient: jjClass=<%x>, cClass=<%x>\n", jjClass, cClass);
    }
}


EXPORTJAVA void
xerox_ilu_IluGCClient_setupSpecialGCObj(
	struct Hxerox_ilu_IluGCClient * unused,
	struct Hxerox_ilu_IluOInt * jjoi) 
{
    ilu_Object cGCObj = Access(jjoi, yIluKernelObject, ilu_Object);
    if (_ilujava_definitionsFlag>0) {
        ilu_DebugPrintf("$ GCClient: cGCObj =<%x>\n", cGCObj);
    }
    ilu_SetGcClient(cGCObj);
}

/* end */
