/* IluJava_JTypes.h */
/* Chris Jacobi, April 7, 1997 5:34 pm PDT */

/*
 * Copyright (c) 1997 Xerox Corporation.  All Rights Reserved.  
 * Unlimited use, reproduction, and distribution of this software is
 * permitted.  Any copy of this software must include both the above
 * copyright notice of Xerox Corporation and this paragraph.  Any
 * distribution of this software must comply with all applicable United
 * States export control laws.  This software is made available AS IS,
 * and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
 * INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
 * PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
 * THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
 * CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
 * XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 */
 
/* $Id: IluJava_JTypes.h,v 1.3 1997/04/08 20:24:28 jacobi Exp $ */

/*
 * Macros to make the java stuff more portable
 */

#ifndef _ILUJAVA_JTypes_
#define _ILUJAVA_JTypes_


#include <StubPreamble.h>
#include <interpreter.h>
#include <javaString.h>

/*
 * These macros define c types used to represent java types
 * according to the java native stub stubber
 */
 
#define Jint long
#define Jshort short
#define Jboolean long
#define Jbyte char
#define Jlong int64_t
#define Jfloat float
#define Jdouble double
#define Jchar unicode

/*
 * Conversion macros
 */

#define TOIluInt64(i) ( * (ilu_longinteger *) &(i))
#define TOJavaIC64(i) ( * (int64_t *) &(i))
#define TOIluCard64(i) ( * (ilu_longcardinal *) &(i))

/*
 * Java system types
 */

#define JString Hjava_lang_String*
#define JArrayOfChar HArrayOfChar*
#define JArrayOfByte HArrayOfByte*
#define JArrayOfString HArrayOfString*
#define JArrayOfInt HArrayOfInt*

/*
 * Ilu classes
 */

#define JIluClassRep Hxerox_ilu_IluClassRep*
#define JIluCall Hxerox_ilu_IluCall*
#define JIluObject Hxerox_ilu_IluObject*
#define JIluMethodRep Hxerox_ilu_IluMethodRep*
#define JIluRT0 Hxerox_ilu_IluRT0*
#define JIluOInt Hxerox_ilu_IluOInt*
#define JIluServer Hxerox_ilu_IluServer*


#endif /* _ILUJAVA_JTypes_ */
